/*
 * AppController.j
 * SimpleOutlineView
 *
 * Created by You on September 18, 2016.
 * Copyright 2016, Your Company All rights reserved.
 */

@import <Foundation/Foundation.j>
@import <AppKit/AppKit.j>
@import "Employee.j"


@implementation AppController : CPObject
{
    @outlet CPWindow            theWindow;
    @outlet CPOutlineView     outlineView;
    Employee                             _ceo; // This will hold our root item
    Employee                             employee;
}

- (id)init
{
    if (self = [super init])
    {
        // First we define our root item, the CEO
        _ceo = [[Employee alloc] initWithName:"Ben" title:"CEO"];

        // Then we create other employees and add them to their managers belong to
        var simon = [[Employee alloc] initWithName:"Simon" title:"CFO"];

        // We collect CEO reportees to his _employees array defined in Employee.j
        // Simon reports directly to CEO
        [[_ceo employees] addObject:simon];

        var sarah = [[Employee alloc] initWithName:"Sarah" title:"Assistant to CFO"];
        // Sarah report to Simon
        [[simon employees] addObject:sarah];

        var maarten = [[Employee alloc] initWithName:"Maarten" title:"VP of Marketing"];
        [[_ceo employees] addObject:maarten];

        var donny = [[Employee alloc] initWithName:"Donny" title:"Head of Communication"];
        [[maarten employees] addObject:donny];

        var ronan = [[Employee alloc] initWithName:"Ronan" title:"Communication Specialist"];
        [[donny employees] addObject:ronan];

        var dick = [[Employee alloc] initWithName:"Dick" title:"Head of Legal"];
        [[_ceo employees] addObject:dick];
    }
    return self;
}

- (void)applicationDidFinishLaunching:(CPNotification)aNotification
{
}

- (void)awakeFromCib
{
    [theWindow setFullPlatformWindow:NO];
}


- (int)outlineView:(CPOutlineView)outlineView numberOfChildrenOfItem:(id)item
{
    if (!item)
    {
        // We have one root item, the CEO only
        return 1
    }

    return [[item employees] count];
}


- (BOOL)outlineView:(CPOutlineView)outlineView isItemExpandable:(id)item
{
    if (!item)
    {
        return YES;
    }

    return [[item employees] count] != 0;
}


- (id)outlineView:(CPOutlineView)outlineView child:(CPInteger)index ofItem:(id)item
{
    if (!item)
    {
        // Our root item is the CEO
        return _ceo;
    }

    return [item employees][index];
}


- (id)outlineView:(id)anOutlineView viewForTableColumn:(id)tableColumn item:(id)item
{
    var identifier = [tableColumn identifier];

    var view = [anOutlineView makeViewWithIdentifier:"NameCell" owner:self];

    if (identifier == "NameColumn")
    {
        [[view textField] setStringValue:[item name]];
    }
    else
    {
        var view = [anOutlineView makeViewWithIdentifier:"TitleCell" owner:self];
        [[view textField] setStringValue:[item title]];
    }
    return view;
}

@end
